using UnityEngine;

public struct TAssets //Short for "Terminator Assets"
{
    //texture2d(s)
    public static Texture2D Terminator_Skin;
    public static Texture2D Terminator_Flesh;
    public static Texture2D Terminator_Skeleton;
    //sprites
    public static Sprite Terminator_Eye;
    public static Sprite TimeSphere;
    public static Sprite TimeSphere_Burn;
    public static Sprite TimeSphere_Thermal;
    public static Sprite TimeSphere_Flash;
    public static Sprite[] TimeSphere_Flicker;
    //sfx
    public static AudioClip Terminator_Limb_BreakSFX;
    public static AudioClip Terminator_DeathSFX;
    public static AudioClip[] Terminator_StepSFX;
    public static AudioClip Terminator_PainSFX;
    public static AudioClip Terminator_RebootSFX;
    public static AudioClip Terminator_TimeBubble;
    //music
    public static AudioClip music_init;
    public static AudioClip[] music_stageneg1;
    public static AudioClip[] music_stage0;
    public static AudioClip[] music_stage1;
    public static AudioClip[] music_stage2;

    public static void Init()
    {
        //texture2d(s)
        Terminator_Skin = ModAPI.LoadTexture("terminator_skin.png");
        Terminator_Flesh = ModAPI.LoadTexture("terminator_flesh.png");
        Terminator_Skeleton = ModAPI.LoadTexture("terminator_skeleton.png");
        //sprites
        Terminator_Eye = ModAPI.LoadSprite("terminator_eye.png");
        TimeSphere = ModAPI.LoadSprite("timesphere.png");
        TimeSphere_Burn = ModAPI.LoadSprite("timesphere_burn.png");
        TimeSphere_Thermal = ModAPI.LoadSprite("timesphere_thermal.png");
        TimeSphere_Flash = ModAPI.LoadSprite("timesphere_flash.png");
        TimeSphere_Flicker = new Sprite[]{
            ModAPI.LoadSprite("timesphere_flicker/flicker0.png"),
            ModAPI.LoadSprite("timesphere_flicker/flicker1.png"),
            ModAPI.LoadSprite("timesphere_flicker/flicker2.png"),
            ModAPI.LoadSprite("timesphere_flicker/flicker3.png"),
            ModAPI.LoadSprite("timesphere_flicker/flicker4.png"),
            ModAPI.LoadSprite("timesphere_flicker/flicker5.png"),
            ModAPI.LoadSprite("timesphere_flicker/flicker6.png"),
            ModAPI.LoadSprite("timesphere_flicker/flicker7.png"),
            ModAPI.LoadSprite("timesphere_flicker/flicker8.png")
        };
        //sfx
        Terminator_Limb_BreakSFX = ModAPI.LoadSound("sfx/limb_break.mp3");
        Terminator_DeathSFX = ModAPI.LoadSound("sfx/dead.mp3");
        Terminator_StepSFX = new AudioClip[]{
            ModAPI.LoadSound("sfx/step_0.mp3"),
            ModAPI.LoadSound("sfx/step_1.mp3")
        };
        Terminator_PainSFX = ModAPI.LoadSound("sfx/pain.mp3");
        Terminator_RebootSFX = ModAPI.LoadSound("sfx/reboot.mp3");
        Terminator_TimeBubble = ModAPI.LoadSound("sfx/time_bubble.mp3");
        //music
        music_init = ModAPI.LoadSound("music/music_init.mp3");
        music_stage0 = new AudioClip[]{
            ModAPI.LoadSound("music/music_stage0_0.mp3"),
            ModAPI.LoadSound("music/music_stage0_1.mp3"),
            ModAPI.LoadSound("music/music_stage0_2.mp3")
        };
        music_stageneg1 = new AudioClip[]{
            ModAPI.LoadSound("music/music_stage-1_0.mp3")
        };
        music_stage1 = new AudioClip[]{
            ModAPI.LoadSound("music/music_stage1_0.mp3"),
            ModAPI.LoadSound("music/music_stage1_1.mp3"),
            ModAPI.LoadSound("music/music_stage1_2.mp3")
        };
        music_stage2 = new AudioClip[]{
            ModAPI.LoadSound("music/music_stage2_0.mp3")
        };
    }

    public static void PlaySFXarray(AudioClip[] Audio, Vector3 Transform){
        PlaySFX(Audio[(int) UnityEngine.Random.Range(0, (Audio.Length - 1))], Transform);
    }

    public static void PlaySFX(AudioClip Audio, Vector3 Transform){
        AudioSource.PlayClipAtPoint(Audio, Transform);
    }
}
