using System;
using System.Collections.Generic;
using System.Collections;
using System.IO;
using UnityEngine;
using UnityEngine.UI;
using System.Linq;
using TMPro;
using UnityEngine.Events;

//                        ______
//                      <((((((\\\
//                      /      . }\
//                      ;--..--._|}
//   (\                 '--/\--'  )
//    \\                | '-'  :'|
//     \\               . -==- .-|
//      \\               \.__.'   \--._
//      [\\          __.--|       //  _/'--.
//      \ \\       .'-._ ('-----'/ __/      \
//       \ \\     /   __>|      | '--.       |
//        \ \\   |   \   |     /    /       /
//         \ '\ /     \  |     |  _/       /
//          \  \       \ |     | /        /
//           \  \      \        /

namespace Mod
{
    public class Mod
    {
        public static void Main()
        {

            classicCB.Create("Terminator", "", ModAPI.LoadSprite("caticon.png", 4));
            
            TAssets.Init();

			ModAPI.Register(
				new Modification()
					{
						OriginalItem = ModAPI.FindSpawnable("Human"),
						NameOverride = "Terminator",
						NameToOrderByOverride = "!!!!!!!1",
						DescriptionOverride = "Cyberdyne Systems 101 T-800 Terminator with dynamic Background Music, a Metal Endoskeleton and a Skynet Neural-Net CPU, Ready to TERMINATE!",
						CategoryOverride = ModAPI.FindCategory("Terminator"),
						ThumbnailOverride = ModAPI.LoadSprite("terminator_icon.png"),
						AfterSpawn = (Instance) =>
						{
							Instance.GetComponent<PersonBehaviour>().SetBodyTextures(TAssets.Terminator_Skin, TAssets.Terminator_Flesh, TAssets.Terminator_Skeleton, 1);
							// person.SetBruiseColor(100, 100, 100);
							// person.SetSecondBruiseColor(100, 100, 100); 
							// person.SetThirdBruiseColor(100, 100, 100); 
							// person.SetBloodColour(100, 100, 100); 
							// person.SetRottenColour(100, 100, 100); 

							var Terminator = Instance.GetComponent<PersonBehaviour>();
                            foreach (var limb in Terminator.Limbs)
                            {
                                TerminatorLimbBehaviour TermiLimb = limb.gameObject.AddComponent<TerminatorLimbBehaviour>();
                                TermiLimb.SkinMaterialHandler = limb.SkinMaterialHandler;
                                TermiLimb.PhysicalBehaviour = limb.PhysicalBehaviour;
                                TermiLimb.LimbBehaviour = limb;
                                //Vector4[] DamagePoints = limb.SkinMaterialHandler.damagePoints;

                                limb.PhysicalBehaviour.InitialMass *= 10f;
                                limb.FreezingTemperature = float.NegativeInfinity;
                                limb.DiscomfortingHeatTemperature = float.PositiveInfinity;
                                limb.Health = 5500f;
							    limb.InitialHealth = 5500f;
                                limb.BreakingThreshold = 5;
                                limb.BaseStrength = 2f;
                                limb.BodyTemperature = 0;
                                limb.InternalTemperature = 0;
                                limb.PhysicalBehaviour.Charge = 0f;
                                limb.ShotDamageMultiplier *= 2.5f;
                                limb.Vitality = 0;
                                limb.DoStumble = false;
                                limb.ExplodeLiquidAmount = float.PositiveInfinity;
                                limb.Numbness = float.PositiveInfinity;
                                limb.ImpactPainMultiplier = 0f;
                                limb.SpeciesIdentity = "Terminator";
                                limb.IsLethalToBreak = false;
                                limb.DoBalanceJerk = false;
                                limb.IsAndroid = true;
                                limb.transform.root.localScale *= 1.003f;
                                limb.PhysicalBehaviour.Properties = ModAPI.FindPhysicalProperties("Human");

                                limb.Person.BoneBreakClips = new AudioClip[] {TAssets.Terminator_Limb_BreakSFX};
                            }
						}
					}
			);
        }
	}
}
