using UnityEngine;
using System.Linq;
using System;
using System.Collections.Generic;
using System.Collections;

public static class TerminatorMusicManager
{

    public static int MusicStage = -2;
    public static bool Active = false;
    public static int ActiveTerminatorCount = 0;
    private static int LastMusicStage = -2;
    public static GameObject MusicObject;
    public static AudioSource AudioSource;
    private static AudioClip TheClip;

    public static void Setup(){
        MusicObject = new GameObject("TerminatorMusicManager");
        AudioSource = MusicObject.AddComponent<AudioSource>();
        AudioSource.playOnAwake = false;
        AudioSource.maxDistance = float.PositiveInfinity;
        AudioSource.loop = true;
        AudioSource.volume *= 0.5f;
    }

    public static void TRegist(){
        if (ActiveTerminatorCount <= 0){//first terminator?
            Setup();
        }
        ActiveTerminatorCount ++;
        Active = true;
        Debug.Log("Terminator " + ActiveTerminatorCount + " Registered");
    }

    public static void TDeRegist(){
        ActiveTerminatorCount --;
        if (ActiveTerminatorCount <= 0){//all terminators removed
            Active = false;
            LastMusicStage = -2;
            MusicStage = -2;
            Debug.Log("All Terminators DeRegistered");
            UnityEngine.Object.Destroy(MusicObject);
        }
        if (ActiveTerminatorCount < 0){ActiveTerminatorCount = 0;}
    }

    public static void MusicProgression(int StageGoal){
        if (StageGoal > MusicStage){
            MusicStage = StageGoal;
            if (LastMusicStage != MusicStage){
                LastMusicStage = MusicStage;
                switch(MusicStage){
                case -1: TheClip = TAssets.music_stageneg1[UnityEngine.Random.Range(0, TAssets.music_stageneg1.Length - 1)]; break;
                case 0: TheClip = TAssets.music_stage0[UnityEngine.Random.Range(0, TAssets.music_stage0.Length - 1)]; break;
                case 1: TheClip = TAssets.music_stage1[UnityEngine.Random.Range(0, TAssets.music_stage1.Length - 1)]; break;
                case 2: TheClip = TAssets.music_stage2[UnityEngine.Random.Range(0, TAssets.music_stage2.Length - 1)]; break;
                default:
                break;
                }
                AudioSource.clip = TheClip;
                AudioSource.Play();
            }
        }
    }

    public static void FixedUpdate()
    {
        //MusicStage();
    }
}
